<?php

if (!defined('ABSPATH')) {
    exit;
}
////////////////////////////////////Codded///by//@NiMiX3////////////////////////////////////////////
function Load_Toptie_Gateway()
{
	if (!function_exists('Woocommerce_Add_Toptie_Gateway') && class_exists('WC_Payment_Gateway') && !class_exists('WC_Toptie'))
	{
		// Add Toptie payment gateway
		add_filter('woocommerce_payment_gateways', 'Woocommerce_Add_Toptie_Gateway');
		function Woocommerce_Add_Toptie_Gateway($methods)
        {
            $methods[] = 'WC_Toptie';
            return $methods;
        }
		
		// Add IR currencies
		/*add_filter('woocommerce_currencies', 'add_IR_currency');
		function add_IR_currency($currencies)
        {
            $currencies['IRR'] = __('ریال', 'woocommerce');
            $currencies['IRT'] = __('تومان', 'woocommerce');
            $currencies['IRHR'] = __('هزار ریال', 'woocommerce');
            $currencies['IRHT'] = __('هزار تومان', 'woocommerce');
            return $currencies;
        }
		add_filter('woocommerce_currency_symbol', 'add_IR_currency_symbol', 10, 2);
		
		// Add IR currencies symbols
		function add_IR_currency_symbol($currency_symbol, $currency)
        {
            switch ($currency) {
                case 'IRR':
                    $currency_symbol = 'ریال';
                    break;
                case 'IRT':
                    $currency_symbol = 'تومان';
                    break;
                case 'IRHR':
                    $currency_symbol = 'هزار ریال';
                    break;
                case 'IRHT':
                    $currency_symbol = 'هزار تومان';
                    break;
            }
            return $currency_symbol;
        }*/
		
		// 
		class WC_Toptie extends WC_Payment_Gateway
        {
			public function __construct()
            {
                $this->id = 'WC_Toptie';
                $this->method_title = __('پرداخت امن تاپ تای', 'woocommerce');
                $this->method_description = __('تنظیمات درگاه پرداخت تاپ تای برای افزونه فروشگاه ساز ووکامرس', 'woocommerce');
                $this->icon = apply_filters('WC_Toptie_logo', WP_PLUGIN_URL . '/' . plugin_basename(__DIR__) . '/assets/images/logo.png');
                $this->has_fields = false;
                $this->init_form_fields();
                $this->init_settings();
                $this->title = $this->settings['title'];
                $this->description = $this->settings['description'];
                $this->merchantEmail = $this->settings['merchantemail'];
				$this->merchantPassword = $this->settings['merchantpassword'];
                $this->successMassage = $this->settings['success_massage'];
                $this->failedMassage = $this->settings['failed_massage'];
				$this->authKey = '';
				$this->invoiceKey = '';
				$this->debug = false;
                if (version_compare(WOOCOMMERCE_VERSION, '2.0.0', '>=')) {
                    add_action('woocommerce_update_options_payment_gateways_' . $this->id, array($this, 'process_admin_options'));
                } else {
                    add_action('woocommerce_update_options_payment_gateways', array($this, 'process_admin_options'));
                }
                add_action('woocommerce_receipt_' . $this->id . '', array($this, 'Send_to_Toptie_Gateway'));
                add_action('woocommerce_api_' . strtolower(get_class($this)) . '', array($this, 'Return_from_Toptie_Gateway'));
            }
			
			// Administration settings
			public function init_form_fields()
            {
                $this->form_fields = apply_filters('WC_Toptie_Config', array(
                        'base_config' => array(
                            'title' => __('تنظیمات اصلی', 'woocommerce'),
                            'type' => 'title',
                            'description' => '',
                        ),
                        'enabled' => array(
                            'title' => __('فعالسازی/غیرفعالسازی', 'woocommerce'),
                            'type' => 'checkbox',
                            'label' => __('فعالسازی درگاه تاپ تای', 'woocommerce'),
                            'description' => __('برای فعالسازی درگاه تاپ تای پال باید چک باکس را تیک بزنید', 'woocommerce'),
                            'default' => 'yes',
                            'desc_tip' => true,
                        ),
                        'title' => array(
                            'title' => __('عنوان درگاه', 'woocommerce'),
                            'type' => 'text',
                            'description' => __('عنوان درگاه که در طی خرید به مشتری نمایش داده میشود', 'woocommerce'),
                            'default' => __('پرداخت امن تاپ تای', 'woocommerce'),
                            'desc_tip' => true,
                        ),
                        'description' => array(
                            'title' => __('توضیحات درگاه', 'woocommerce'),
                            'type' => 'text',
                            'desc_tip' => true,
                            'description' => __('توضیحاتی که در طی عملیات پرداخت برای درگاه نمایش داده خواهد شد', 'woocommerce'),
                            'default' => __('پرداخت امن به وسیله کلیه کارت های عضو شتاب از طریق درگاه تاپ تای', 'woocommerce')
                        ),
                        'account_config' => array(
                            'title' => __('تنظیمات حساب تاپ تای', 'woocommerce'),
                            'type' => 'title',
                            'description' => '',
                        ),
                        'merchantemail' => array(
                            'title' => __('ایمیل پذیرنده', 'woocommerce'),
                            'type' => 'text',
                            'description' => __('ایمیل پذیرنده تاپ تای', 'woocommerce'),
                            'default' => '',
                            'desc_tip' => true
                        ),
						'merchantpassword' => array(
                            'title' => __('پسورد پذیرنده', 'woocommerce'),
                            'type' => 'password',
                            'description' => __('پسورد پذیرنده تاپ تای', 'woocommerce'),
                            'default' => '',
                            'desc_tip' => true
                        ),
                        'payment_config' => array(
                            'title' => __('تنظیمات عملیات پرداخت', 'woocommerce'),
                            'type' => 'title',
                            'description' => '',
                        ),
                        'success_massage' => array(
                            'title' => __('پیام پرداخت موفق', 'woocommerce'),
                            'type' => 'textarea',
                            'description' => __('متن پیامی که میخواهید بعد از پرداخت موفق به کاربر نمایش دهید را وارد نمایید . همچنین می توانید از شورت کد {transaction_id} برای نمایش کد رهگیری (توکن) زرین پال استفاده نمایید .', 'woocommerce'),
                            'default' => __('با تشکر از شما . سفارش شما با موفقیت پرداخت شد .', 'woocommerce'),
                        ),
                        'failed_massage' => array(
                            'title' => __('پیام پرداخت ناموفق', 'woocommerce'),
                            'type' => 'textarea',
                            'description' => __('متن پیامی که میخواهید بعد از پرداخت ناموفق به کاربر نمایش دهید را وارد نمایید . همچنین می توانید از شورت کد {fault} برای نمایش دلیل خطای رخ داده استفاده نمایید . این دلیل خطا از سایت زرین پال ارسال میگردد .', 'woocommerce'),
                            'default' => __('پرداخت شما ناموفق بوده است . لطفا مجددا تلاش نمایید یا در صورت بروز اشکال با مدیر سایت تماس بگیرید .', 'woocommerce'),
                        ),
                    )
                );
            }
			
			// Default payment process
			public function process_payment($order_id)
            {
                $order = new WC_Order($order_id);
                return array(
                    'result' => 'success',
                    'redirect' => $order->get_checkout_payment_url(true)
                );
            }
			
			// Send auth to toptie and get token
			public function sendAuthRequestToptie($email,$password,$usertype=0)
			{
				$curl = curl_init();
				curl_setopt_array($curl, array(
				CURLOPT_URL => 'http://api.toptie.net/api/v1/login',
				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_ENCODING => '',
				CURLOPT_MAXREDIRS => 10,
				CURLOPT_TIMEOUT => 0,
				CURLOPT_FOLLOWLOCATION => true,
				CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
				CURLOPT_CUSTOMREQUEST => 'POST',
				CURLOPT_POSTFIELDS =>'{
				"email": "'.$email.'" ,
				"password" : "'.$password.'" ,
				"usertype" : '.$usertype.' 
				}
				',// json_encode(array('email'=>$email,'password'=>$password,'usertype'=>$usertype))
				CURLOPT_HTTPHEADER => array(
					'Content-Type: application/json'
				),
				));
				$response = curl_exec($curl);
				curl_close($curl);
				if($this->debug)
					var_dump($response);
				return $response;
			}
			
			// Send invoice to toptie and get payment
			public function sendInvoiceRequestToptie($Token,$Data)
			{
				$curl = curl_init();
				curl_setopt_array($curl, array(
				CURLOPT_URL => 'http://api.toptie.net/api/v1/invoice',
				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_ENCODING => '',
				CURLOPT_MAXREDIRS => 10,
				CURLOPT_TIMEOUT => 0,
				CURLOPT_FOLLOWLOCATION => true,
				CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
				CURLOPT_CUSTOMREQUEST => 'POST',
				CURLOPT_POSTFIELDS =>$Data,
				CURLOPT_HTTPHEADER => array(
					'Accept: application/json',
					'Authorization: Bearer '.$Token,
					'Content-Type: application/json'
				),
				));
				$response = curl_exec($curl);
				curl_close($curl);
				if($this->debug)
					var_dump($response);
				return $response;
			}
			
			// Send verification to toptie and complete
			public function sendVerifyRequestToptie($Token,$Invoice)
			{
				$curl = curl_init();
				curl_setopt_array($curl, array(
				CURLOPT_URL => 'http://api.toptie.net/api/v1/verify',
				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_ENCODING => '',
				CURLOPT_MAXREDIRS => 10,
				CURLOPT_TIMEOUT => 0,
				CURLOPT_FOLLOWLOCATION => true,
				CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
				CURLOPT_CUSTOMREQUEST => 'POST',
				CURLOPT_POSTFIELDS => '{
				"invoice_key": "'.$Invoice.'"
				}',//json_encode(array('Invoice_key' => $Invoice)),
				CURLOPT_HTTPHEADER => array(
					'Accept: application/json',
					'Authorization: Bearer '.$Token,
					'Content-Type: application/json'
				),
				));
				$response = curl_exec($curl);
				curl_close($curl);
				if($this->debug)
					var_dump($response);
				return $response;
			}
			
			// Request sender
			public function sendRequestToToptie($action, $params)
            {
                try {
                    $retry = 5;
                    $response = null;
                    while ($retry > 0) {
                        $response = wp_safe_remote_post('https://api.toptie.net/api/v1/' . $action, array(
                            'body' => $params,
                            'headers' => array(
                                'Content-Type' => 'application/json',
                                'Content-Length' =>   strlen($params) ,
                                'User-Agent' => 'Toptie Rest Api v1'
                            )
                        ));
                        if (is_wp_error($response)) {
                            $retry--;
                            continue;
                        } else {
                            break;
                        }
                    }
                    $body = wp_remote_retrieve_body($response);
                    return json_decode($body, true);
                } catch (Exception $ex) {
                    return false;
                }
            }
////////////////////////////////////Codded///by//@NiMiX3////////////////////////////////////////////
			public function Send_to_Toptie_Gateway($order_id)
            {
                global $woocommerce;
                $woocommerce->session->order_id_toptie = $order_id;
                $order = new WC_Order($order_id);
                $currency = $order->get_currency();
                $currency = apply_filters('WC_Toptie_Currency', $currency, $order_id);
                $form = '<form action="" method="POST" class="toptie-checkout-form" id="toptie-checkout-form">
                        <input type="submit" name="toptie_submit" class="button alt" id="toptie-payment-button" value="' . __('پرداخت', 'woocommerce') . '"/>
                        <a class="button cancel" href="' . wc_get_checkout_url() . '">' . __('بازگشت', 'woocommerce') . '</a>
                     </form><br/>';
                $form = apply_filters('WC_Toptie_Form', $form, $order_id, $woocommerce);
                do_action('WC_Toptie_Gateway_Before_Form', $order_id, $woocommerce);
                echo wp_kses($form,array(
                    'form'=>array('action','method','class','id'),
                    'input'=>array('type','name','class','id','value'),
                    'a'=>array('class','href')
                ));
                do_action('WC_Toptie_Gateway_After_Form', $order_id, $woocommerce);
                $Amount = (int)$order->get_total();
				
                $strToLowerCurrency = strtolower($currency);
                $CallbackUrl = add_query_arg('wc_order', $order_id, WC()->api_request_url('WC_Toptie'));
                $Mobile = get_post_meta($order_id, '_billing_phone', true) ?: '-';
                $Email = $order->get_billing_email();
                $Payer = $order->get_billing_first_name() . ' ' . $order->get_billing_last_name();
                $ResNumber = (int)$order->get_order_number();

                //Hooks for developers
                $Description = apply_filters('WC_Toptie_Description', $Description, $order_id);
                $Mobile = apply_filters('WC_Toptie_Mobile', $Mobile, $order_id);
                $Email = apply_filters('WC_Toptie_Email', $Email, $order_id);
                $Payer = apply_filters('WC_Toptie_Paymenter', $Payer, $order_id);
                $ResNumber = apply_filters('WC_Toptie_ResNumber', $ResNumber, $order_id);
                do_action('WC_Toptie_Gateway_Payment', $order_id, $Description, $Mobile);
                $Email = !filter_var($Email, FILTER_VALIDATE_EMAIL) === false ? $Email : '';
                $Mobile = preg_match('/^09[0-9]{9}/i', $Mobile) ? $Mobile : '';
				
				// Get AuthKey(Token) for Invoice
				$result = $this->sendAuthRequestToptie($this->merchantEmail,$this->merchantPassword,0);
				$result = json_decode($result,true);
                if ($result === false)
				{
                    echo esc_html('cURL Error #:');
					$Fault = 'Connection Error';
					do_action('WC_Toptie_Send_to_Gateway_Failed', $order_id, $Fault);
                }
				else if ($result['success'] == 1)
				{
					$this->authKey = $result['data']['token'];
                }
				else
				{
                    $Message = ' احراز هویت پذیرنده با خطا مواجه شده است: ' . $result['message'];
                    $Fault = 'Authenticaion Error';
					do_action('WC_Toptie_Send_to_Gateway_Failed', $order_id, $Fault);
                }
				
				// Send Invoice to Toptie
				$products = array();
				$qty = 0;
				$tprc = 0;
                $order_items = $order->get_items();
                foreach ($order_items as $pid => $product)
				{
					$products[] = array('product_id'=> $product->get_product_id() ,'product_name'=>$product->get_name() ,'product_subname'=>$product->get_name() ,'product_price'=>$product->get_total() ,'product_amount'=>$product->get_quantity());
                    $qty += intval($product->get_quantity());
					$tprc += floatval($product->get_total());
                }
                $orderdata = array(
					'invoice_id' => $order->get_id(),
					'total_amount' => $order->get_item_count(), // $qty
					'total_price' => $tprc, //(float)$order->get_total(),
					//*'total_discount' => $order->get_discount_total(),
					//*'total_tax' => $order->get_order_tax(), //get_cart_tax()
					//*'total_shipping' => $order->get_shipping_total(),
					'buyer_name' => $order->get_billing_first_name() . ' ' . $order->get_billing_last_name(),
					//*'buyer_ip' => $order->get_customer_ip_address(),
					//*'buyer_note' => $order->get_customer_note(),
					'currency' => $order->get_currency(),
					'return_url' => $CallbackUrl,
					'products' => $products,
				);
				$result = null;
				$result = $this->sendInvoiceRequestToptie($this->authKey,json_encode($orderdata));
				$result = json_decode($result,true);
                if ($result === false)
				{
                    echo esc_html('cURL Error #:');
					$Fault = 'Connection Error';
					do_action('WC_Toptie_Send_to_Gateway_Failed', $order_id, $Fault);
                }
				else if ($result['success'] == 1)
				{
					$this->invoiceKey = $result['data']['invoice_key'];
					$woocommerce->session->invoiceKey = $this->invoiceKey;
					if(!$this->debug)
					{
						header('Location: http://api.toptie.net/checkout-toptieapi/' . $this->invoiceKey);
						exit;
					}
					else
					{
						print('حالت خطایابی فعال است! به درگاه هدایت نمی شود.');
					}
                }
				else
				{
                    $Message = ' اتصال به درگاه پرداخت با خطا مواجه شد: ' . $result['message'];
                    $Fault = 'Gateway Error';
					wc_add_notice($Message, 'error');
					$order->add_order_note($Message);
					print($Message);
                    do_action('WC_Toptie_Send_to_Gateway_Failed', $order_id, $Fault);
                }
            }
////////////////////////////////////Codded///by//@NiMiX3////////////////////////////////////////////
			public function Return_from_Toptie_Gateway()
            {
                $InvoiceNumber = isset($_POST['InvoiceNumber']) ? sanitize_text_field($_POST['InvoiceNumber'] ): '';
                global $woocommerce;
                if (isset($_GET['wc_order']))
				{
                    $order_id = sanitize_text_field($_GET['wc_order']) ;
                }
				else if ($InvoiceNumber)
				{
                    $order_id = $InvoiceNumber;
                }
				else
				{
                    $order_id = $woocommerce->session->order_id_toptie;
                    unset($woocommerce->session->order_id_toptie);
                }
                if ($order_id)
				{
                    $order = new WC_Order($order_id);
                    $currency = $order->get_currency();
                    $currency = apply_filters('WC_Toptie_Currency', $currency, $order_id);
                    if ($order->status !== 'completed')
					{
						// Get AuthKey(Token) for Invoice
						$result = $this->sendAuthRequestToptie($this->merchantEmail,$this->merchantPassword,0);
						$result = json_decode($result,true);
						if ($result === false)
						{
							echo esc_html('cURL Error #:');
							$Fault = 'Connection Error';
							do_action('WC_Toptie_Send_to_Gateway_Failed', $order_id, $Fault);
							wc_add_notice($Fault, 'error');
							$order->add_order_note($Fault);
							wp_redirect(wc_get_checkout_url());
							exit;
						}
						else if ($result['success'] == 1)
						{
							$this->authKey = $result['data']['token'];
						}
						else
						{
							$Message = ' احراز هویت پذیرنده با خطا مواجه شده است: ' . $result['message'];
							$Fault = 'Authenticaion Error';
							do_action('WC_Toptie_Send_to_Gateway_Failed', $order_id, $Fault);
							wc_add_notice($Message, 'error');
							$order->add_order_note($Message);
							wp_redirect(wc_get_checkout_url());
							exit;
						}
						$this->invoiceKey = $woocommerce->session->invoiceKey;
						unset($woocommerce->session->invoiceKey);
                        $result = $this->sendVerifyRequestToptie($this->authKey,$this->invoiceKey);
						$result = json_decode($result,true);
						if ($result === false)
						{
							$Status = 'failed';
                            $Fault = '';
                            $Message = 'تراکنش انجام نشد، خطا سروری رخ داده است';
							wc_add_notice($Message, 'error');
							$order->add_order_note($Message);
							wp_redirect(wc_get_checkout_url());
							exit;
						}
						else if ($result['success'] == 1)
						{
							$payresu = $result['data']['result_pay'];
							if($payresu === 'approved')
							{
								$Transaction_ID = get_post_meta($order_id, '_transaction_id', true);
								update_post_meta($order_id, '_transaction_id', $Transaction_ID);
								$order->payment_complete($Transaction_ID);
								$woocommerce->cart->empty_cart();
								$Note = sprintf(__('پرداخت موفقیت آمیز بود .<br/> کد رهگیری : %s', 'woocommerce'), $Transaction_ID);
								$Note = apply_filters('WC_Toptie_Return_from_Gateway_Success_Note', $Note, $order_id, $Transaction_ID);
								if ($Note)
									$order->add_order_note($Note, 1);
								$Notice = wpautop(wptexturize($this->successmessage));
								$Notice = str_replace('{transaction_id}', $Transaction_ID, $Notice);
								$Notice = apply_filters('WC_Toptie_Return_from_Gateway_Success_Notice', $Notice, $order_id, $Transaction_ID);
								if ($Notice)
									wc_add_notice($Notice, 'success');
								print($Message);
								do_action('WC_Toptie_Return_from_Gateway_Success', $order_id, $Transaction_ID);
								wp_redirect(add_query_arg('wc_status', 'success', $this->get_return_url($order)));
								exit;
							}
							else
							{
								$Note = sprintf(__('خطا در هنگام بازگشت از بانک : %s %s', 'woocommerce'), $Message, $tr_id);
								$Note = apply_filters('WC_Toptie_Return_from_Gateway_Failed_Note', $Note, $order_id, $Transaction_ID, $Fault);
								if ($Note)
								{
									$order->add_order_note($Note, 1);
								}
								$Notice = wpautop(wptexturize($this->failedmessage));
								$Notice = str_replace(array('{transaction_id}', '{fault}'), array($Transaction_ID, $Message), $Notice);
								$Notice = apply_filters('WC_Toptie_Return_from_Gateway_Failed_Notice', $Notice, $order_id, $Transaction_ID, $Fault);
								if ($Notice) {
									wc_add_notice($Notice, 'error');
								}
								do_action('WC_Toptie_Return_from_Gateway_Failed', $order_id, $Transaction_ID, $Fault);
								wp_redirect(wc_get_checkout_url());
								exit;
							}
						}
						else
						{
							$Status = 'failed';
                            $Message = 'تراکنش انجام نشد.' . $result['message'];
							wc_add_notice($Message, 'error');
							$order->add_order_note($Message);
							wp_redirect(wc_get_checkout_url());
							exit;
						}
                    }
                }
				else
				{
					$Fault = __('شماره سفارش وجود ندارد .', 'woocommerce');
					$Notice = wpautop(wptexturize($this->failedmessage));
					$Notice = str_replace('{fault}', $Fault, $Notice);
					$Notice = apply_filters('WC_Toptie_Return_from_Gateway_No_Order_ID_Notice', $Notice, $order_id, $Fault);
					if ($Notice)
					{
						wc_add_notice($Notice, 'error');
					}
					do_action('WC_Toptie_Return_from_Gateway_No_Order_ID', $order_id, '0', $Fault);
					wp_redirect(wc_get_checkout_url());
					exit;
				}
            }
		}
	}
}
////////////////////////////////////Codded///by//@NiMiX3////////////////////////////////////////////
add_action('plugins_loaded', 'Load_Toptie_Gateway', 0);
?>